// M30xDemo.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "M30xDemo.h"
#include "M30xDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
BOOLEAN fWin98Flag = FALSE;

/////////////////////////////////////////////////////////////////////////////
// CM30xDemoApp

BEGIN_MESSAGE_MAP(CM30xDemoApp, CWinApp)
	//{{AFX_MSG_MAP(CM30xDemoApp)
	ON_COMMAND(ID_CONTEXT_HELP, CWinApp::OnHelpFinder)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//		ON_COMMAND(ID_CONTEXT_HELP, CWinApp::OnHelpFinder)

/////////////////////////////////////////////////////////////////////////////
// CM30xDemoApp construction

CM30xDemoApp::CM30xDemoApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	p_ConectDevIDList = ConectDevIDList;
	p_CfgDevIDList = CfgDevIDList;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CM30xDemoApp object

CM30xDemoApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CM30xDemoApp initialization

BOOL CM30xDemoApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

//////////Initialization added here//////////////


	// 5-6-02 START OF ADDED ###################
	OSVERSIONINFO structOS_ver;
	structOS_ver.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&structOS_ver);

	if(structOS_ver.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS)
		fWin98Flag = TRUE;
	else
		fWin98Flag = FALSE;
	// 5-6-02 END OF ADDED #####################

	if(fWin98Flag)
		hLibM301CPP = LoadLibrary ("LL_USB.dll");
	else
		hLibM301CPP = LoadLibrary ("LL_USB2k.dll");

	if(hLibM301CPP == NULL){
  	  	MessageBox(0,"Failed to load DLL","ERROR",MB_OK);
		return FALSE;//can't run anything if failed to load DLL
	}
	if(!CheckLibFuncs()){
  	  	MessageBox(0,"Some functions are missing in DLL","ERROR",MB_OK);
		return FALSE;//can't run anything if failed to load DLL
	}
	for(BYTE i = 0; i < MAX_NUM_DEVICE; i++){
		m_pScanDlg[i] = NULL;
	}
///////////////////////////////////////////////////////////////////
	
	CM30xDemoDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	if(hLibM301CPP)	FreeLibrary(hLibM301CPP);
	return FALSE;
}

/****************************************************************************
*
*   Function:			CheckLibFuncs()
*	description:		check if all function have valid address
*	input:				none
*   output:				TRUE/FALSE
*	global variable:	
****************************************************************************/
BOOL CM30xDemoApp::CheckLibFuncs()
{
	pDLL_SetAppMessaging = (P_DLL_SET_APP_MESSAGING)GetProcAddress(hLibM301CPP, "DLL_SetAppMessaging_CPP");
	if(!pDLL_SetAppMessaging) return FALSE;
	pDLL_Init = (P_DLL_INIT)GetProcAddress(hLibM301CPP, "DLL_Init");
	if(!pDLL_Init) return FALSE;
	pDLL_GetDeviceIDList = (P_DLL_GET_DEVICE_ID_LIST)GetProcAddress(hLibM301CPP, "DLL_GetDeviceIDList");
	if(!pDLL_GetDeviceIDList) return FALSE;
	pDLL_GetVersionInfo = (P_DLL_GET_VERSION_INFO)GetProcAddress(hLibM301CPP, "DLL_GetVersionInfo");
	if(!pDLL_GetVersionInfo) return FALSE;
	pDLL_ResetDevice = (P_DLL_RESET_DEVICE)GetProcAddress(hLibM301CPP, "DLL_ResetDevice");
	if(!pDLL_ResetDevice) return FALSE;
	pDLL_InstanceInitDeviceList = (P_DLL_INSTANCE_INIT_DEVICE_LIST)GetProcAddress(hLibM301CPP, "DLL_InstanceInitDeviceList");
	if(!pDLL_InstanceInitDeviceList) return FALSE;
	pDLL_ReleaseDeviceFromIDList = (P_DLL_RELEASE_DEVICE_FROM_IDLIST)GetProcAddress(hLibM301CPP, "DLL_ReleaseDeviceFromIDList");
	if(!pDLL_ReleaseDeviceFromIDList) return FALSE;
	pDLL_SetRate = (P_DLL_SET_RATE)GetProcAddress(hLibM301CPP, "DLL_SetRate");
	if(!pDLL_SetRate) return FALSE;
	pDLL_ReadWriteOneDevice = (P_DLL_READ_WRITE_ONE_DEVICE)GetProcAddress(hLibM301CPP, "DLL_ReadWriteOneDevice");
	if(!pDLL_ReadWriteOneDevice) return FALSE;
	pDLL_StartScan = (P_DLL_START_SCAN)GetProcAddress(hLibM301CPP, "DLL_StartScan_DIO");
	if(!pDLL_StartScan) return FALSE;
	pDLL_EndScan = (P_DLL_END_SCAN)GetProcAddress(hLibM301CPP, "DLL_EndScan_DIO");
	if(!pDLL_EndScan) return FALSE;
	pDLL_ReadScanData = (P_DLL_READ_SCAN_DATA)GetProcAddress(hLibM301CPP, "DLL_ReadScanData_DIO");
	if(!pDLL_ReadScanData) return FALSE;
	pDLL_ReadScanDataWithDigin = (P_DLL_READ_SCAN_DATA_WITH_DI)GetProcAddress(hLibM301CPP, "DLL_ReadScanDataWithDigin");
	if(!pDLL_ReadScanDataWithDigin) return FALSE;
	pDLL_ReInitOneDev = (P_DLL_REINIT_ONEDEV)GetProcAddress(hLibM301CPP, "DLL_ReInitOneDev");
	if(!pDLL_ReInitOneDev) return FALSE;
	pDLL_GetEndOfScanBuffSize = (P_DLL_GETENDOFSCANBUFFSIZE)GetProcAddress(hLibM301CPP, "DLL_GetEndOfScanBuffSize");
	if(!pDLL_GetEndOfScanBuffSize) return FALSE;
	pDLL_SetSpecialDebugOptions = (P_DLL_SETSPECIALDEBUGOPTIONS)GetProcAddress(hLibM301CPP, "DLL_SetSpecialDebugOptions");
	if(!pDLL_SetSpecialDebugOptions) return FALSE;
	pDLL_ResetPipe = (P_DLL_RESETPIPE)GetProcAddress(hLibM301CPP, "DLL_ResetPipe");
	if(!pDLL_ResetPipe) return FALSE;
	return TRUE;
}




