// M30xDemo.h : main header file for the M30XDEMO application
//

#if !defined(AFX_M30XDEMO_H__AD6E16D3_D136_424F_8713_2F7C5F48D330__INCLUDED_)
#define AFX_M30XDEMO_H__AD6E16D3_D136_424F_8713_2F7C5F48D330__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols
#include "ScanDlg.h"
#include "M30xFun.h"


#define MAX_NUM_DEVICE 32
/////////////////////////////////////////////////////////////////////////////
// CM30xDemoApp:
// See M30xDemo.cpp for the implementation of this class
//

#define CONV_VOLT(counts)((counts  - 8388608) * 0.00000059604645)



struct M301_CONFIG_DATA{
	USHORT usDevID;
	BYTE bChan;
	double fRate;
	BYTE bIsActive;
};


typedef void (*P_DLL_MESSAGING_WINDOW_FUNC)(char*  msg);
typedef HANDLE (*P_DLL_SET_APP_MESSAGING)(BOOLEAN fEnable, P_DLL_MESSAGING_WINDOW_FUNC pMessagingWindowFunc);
typedef BOOLEAN (*P_DLL_INIT)(HANDLE _hAppMainWin, HANDLE hLibSETUPAPI, HANDLE hLibUSER32,
			SHORT sDebugLevel, BYTE* bNumDevicesShared, BYTE* DeviceStatusShared,
			USHORT *ConectDevIDList);
typedef BOOLEAN(*P_DLL_GET_DEVICE_ID_LIST)(void);
typedef BOOLEAN(*P_DLL_GET_VERSION_INFO)(USHORT usDevID, BOOLEAN fDisplayVersion, 
				USHORT* usDevVersion, char* cpDLLVersion, char* cpDrvrVersion);
typedef BOOLEAN(*P_DLL_RESET_DEVICE)(USHORT usDevID, BYTE bReserved);
typedef BOOLEAN(*P_DLL_INSTANCE_INIT_DEVICE_LIST)(BOOLEAN fShowLists);
typedef BOOLEAN(*P_DLL_RELEASE_DEVICE_FROM_IDLIST)
		(USHORT* usLLABS_DeviceIDToRelease, BOOLEAN fAnyHandle);
typedef BOOLEAN(*P_DLL_SET_RATE)(USHORT usDevID, double sRate);
typedef BOOLEAN (*P_DLL_READ_WRITE_ONE_DEVICE)(BOOLEAN fReadWrite, 
		BYTE* pDynamicArray, USHORT usDevID, UINT* pNumBytesToRead, 
		  BYTE* pbDigIn, UINT ulTimeOut);
typedef BOOLEAN (*P_DLL_START_SCAN)(USHORT usDevID, 
						_SCAN_OBJECT_DIO *pScanObj, BYTE bStartMode);
typedef BOOLEAN (*P_DLL_READ_SCAN_DATA)(USHORT usDevID, UINT* ulRawCntsBuff, 
							USHORT numPointsToRead, _SCAN_OBJECT_DIO *pScanObj);
typedef BOOLEAN (*P_DLL_READ_SCAN_DATA_WITH_DI)(USHORT usDevID, UINT* ulRawCntsBuff, BYTE* pbDiginBuff,
							BYTE* pbCurChan,USHORT numPointsToRead, _SCAN_OBJECT_DIO *pScanObj);
typedef BOOLEAN (*P_DLL_END_SCAN)(USHORT usDevID, BOOLEAN fReserved, 
					 UINT uiReserved, BYTE reserved);

typedef BOOLEAN (*P_DLL_REINIT_ONEDEV)(USHORT usDevID);

typedef BOOLEAN (*P_DLL_GETENDOFSCANBUFFSIZE)(USHORT usDevID, UINT* uiNumPoints);

typedef BOOLEAN (*P_DLL_SETSPECIALDEBUGOPTIONS)(USHORT* usDeviceIdsToEnableDisable, BYTE* bPerDevDbgLvl, BYTE bDefaultDbgLvl, UINT uiFlags);

typedef BOOLEAN(*P_DLL_RESETPIPE)(USHORT usDevID, BYTE bReserved, BOOLEAN fRead);


class CM30xDemoApp : public CWinApp
{
public:
	CM30xDemoApp();

	HMODULE hLibM301CPP;
	BYTE bDeviceStatus;
	BYTE bNumDevices;
	HANDLE hMainWnd;

	P_DLL_SET_APP_MESSAGING pDLL_SetAppMessaging;
	P_DLL_INIT pDLL_Init;
	P_DLL_GET_DEVICE_ID_LIST pDLL_GetDeviceIDList;
	P_DLL_GET_VERSION_INFO pDLL_GetVersionInfo;
	P_DLL_RESET_DEVICE pDLL_ResetDevice;
	P_DLL_INSTANCE_INIT_DEVICE_LIST pDLL_InstanceInitDeviceList;
	P_DLL_SET_RATE  pDLL_SetRate;
	P_DLL_RELEASE_DEVICE_FROM_IDLIST pDLL_ReleaseDeviceFromIDList;
	P_DLL_READ_WRITE_ONE_DEVICE pDLL_ReadWriteOneDevice;
	P_DLL_START_SCAN pDLL_StartScan;
	P_DLL_READ_SCAN_DATA pDLL_ReadScanData;
	P_DLL_READ_SCAN_DATA_WITH_DI pDLL_ReadScanDataWithDigin;
	P_DLL_END_SCAN pDLL_EndScan;
	P_DLL_REINIT_ONEDEV pDLL_ReInitOneDev;
	P_DLL_GETENDOFSCANBUFFSIZE pDLL_GetEndOfScanBuffSize;
	P_DLL_SETSPECIALDEBUGOPTIONS pDLL_SetSpecialDebugOptions;
	P_DLL_RESETPIPE pDLL_ResetPipe;
	CScanDlg* m_pScanDlg[MAX_NUM_DEVICE];
	USHORT ConectDevIDList[MAX_NUM_DEVICE];
	USHORT *p_ConectDevIDList;

	USHORT CfgDevIDList[MAX_NUM_DEVICE];
	USHORT *p_CfgDevIDList;

	M301_CONFIG_DATA asConfigData[MAX_NUM_DEVICE];


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CM30xDemoApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL
// Implementation
	//{{AFX_MSG(CM30xDemoApp)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	BOOL CheckLibFuncs(void);
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_M30XDEMO_H__AD6E16D3_D136_424F_8713_2F7C5F48D330__INCLUDED_)
